define(["jquery"],function (jq) {

	"use strict";

	return function (context, metadata) {

	    var uiText = (function() {

                var fallbackLanguage = "en-us",
                    texts = {
                        "player": {
                            "navigation": {
                                "progress": {
                                    "textShort": {
                                        "both": {
                                            "et-ee": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "bg-bg": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "cs-cz": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "da-dk": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "de-de": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "en-us": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "es-es": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "fi-fi": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "fr-fr": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "el-gr": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "hi-in": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "hr-hr": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "hu-hu": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "it-it": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "ja-jp": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "ko-kr": "#currentPage#/#maxPages#(#mainCurrentPage#/#mainMaxPages#)",
                                            "lt-lt": "#currentPage# / #maxPages# (#mainCurrentPage# / #mainMaxPages#)",
                                            "mk-mk": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "mn-mn": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "ms-id": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "nl-nl": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "no-no": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "pl-pl": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "pt-pt": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "ro-ro": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "ru-ru": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "sk-sk": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "sl-si": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "sr-rs": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "sv-se": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "th-th": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "tr-tr": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "zh-tw": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "zh-cn": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "de-at": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "de-ch": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "eo-de": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "nl-be": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "en-ie": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "en-gb": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "eo-en": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "fr-be": "#currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)"
                                        },
                                        "main": {
                                            "et-ee": "#currentPage#/#maxPages#",
                                            "bg-bg": "#currentPage#/#maxPages#",
                                            "cs-cz": "#currentPage#/#maxPages#",
                                            "da-dk": "#currentPage#/#maxPages#",
                                            "de-de": "#currentPage#/#maxPages#",
                                            "en-us": "#currentPage#/#maxPages#",
                                            "es-es": "#currentPage#/#maxPages#",
                                            "fi-fi": "#currentPage#/#maxPages#",
                                            "fr-fr": "#currentPage#/#maxPages#",
                                            "el-gr": "#currentPage#/#maxPages#",
                                            "hi-in": "#currentPage#/#maxPages#",
                                            "hr-hr": "#currentPage#/#maxPages#",
                                            "hu-hu": "#currentPage#/#maxPages#",
                                            "it-it": "#currentPage#/#maxPages#",
                                            "ja-jp": "#currentPage#/#maxPages#",
                                            "ko-kr": "#currentPage#/#maxPages#",
                                            "lt-lt": "#currentPage# / #maxPages#",
                                            "mk-mk": "#currentPage#/#maxPages#",
                                            "mn-mn": "#currentPage#/#maxPages#",
                                            "ms-id": "#currentPage#/#maxPages#",
                                            "nl-nl": "#currentPage#/#maxPages#",
                                            "no-no": "#currentPage#/#maxPages#",
                                            "pl-pl": "#currentPage#/#maxPages#",
                                            "pt-pt": "#currentPage#/#maxPages#",
                                            "ro-ro": "#currentPage#/#maxPages#",
                                            "ru-ru": "#currentPage#/#maxPages#",
                                            "sk-sk": "#currentPage#/#maxPages#",
                                            "sl-si": "#currentPage#/#maxPages#",
                                            "sr-rs": "#currentPage#/#maxPages#",
                                            "sv-se": "#currentPage#/#maxPages#",
                                            "th-th": "#currentPage#/#maxPages#",
                                            "tr-tr": "#currentPage#/#maxPages#",
                                            "zh-tw": "#currentPage#/#maxPages#",
                                            "zh-cn": "#currentPage#/#maxPages#",
                                            "de-at": "#currentPage#/#maxPages#",
                                            "de-ch": "#currentPage#/#maxPages#",
                                            "eo-de": "#currentPage#/#maxPages#",
                                            "nl-be": "#currentPage#/#maxPages#",
                                            "en-ie": "#currentPage#/#maxPages#",
                                            "en-gb": "#currentPage#/#maxPages#",
                                            "eo-en": "#currentPage#/#maxPages#",
                                            "fr-be": "#currentPage#/#maxPages#"
                                        },
                                        "sub": {
                                            "et-ee": "#currentPage#/#maxPages#",
                                            "bg-bg": "#currentPage#/#maxPages#",
                                            "cs-cz": "#currentPage#/#maxPages#",
                                            "da-dk": "#currentPage#/#maxPages#",
                                            "de-de": "#currentPage#/#maxPages#",
                                            "en-us": "#currentPage#/#maxPages#",
                                            "es-es": "#currentPage#/#maxPages#",
                                            "fi-fi": "#currentPage#/#maxPages#",
                                            "fr-fr": "#currentPage#/#maxPages#",
                                            "el-gr": "#currentPage#/#maxPages#",
                                            "hi-in": "#currentPage#/#maxPages#",
                                            "hr-hr": "#currentPage#/#maxPages#",
                                            "hu-hu": "#currentPage#/#maxPages#",
                                            "it-it": "#currentPage#/#maxPages#",
                                            "ja-jp": "#currentPage#/#maxPages#",
                                            "ko-kr": "#currentPage#/#maxPages#",
                                            "lt-lt": "#currentPage# / #maxPages#",
                                            "mk-mk": "#currentPage#/#maxPages#",
                                            "mn-mn": "#currentPage#/#maxPages#",
                                            "ms-id": "#currentPage#/#maxPages#",
                                            "nl-nl": "#currentPage#/#maxPages#",
                                            "no-no": "#currentPage#/#maxPages#",
                                            "pl-pl": "#currentPage#/#maxPages#",
                                            "pt-pt": "#currentPage#/#maxPages#",
                                            "ro-ro": "#currentPage#/#maxPages#",
                                            "ru-ru": "#currentPage#/#maxPages#",
                                            "sk-sk": "#currentPage#/#maxPages#",
                                            "sl-si": "#currentPage#/#maxPages#",
                                            "sr-rs": "#currentPage#/#maxPages#",
                                            "sv-se": "#currentPage#/#maxPages#",
                                            "th-th": "#currentPage#/#maxPages#",
                                            "tr-tr": "#currentPage#/#maxPages#",
                                            "zh-tw": "#currentPage#/#maxPages#",
                                            "zh-cn": "#currentPage#/#maxPages#",
                                            "de-at": "#currentPage#/#maxPages#",
                                            "de-ch": "#currentPage#/#maxPages#",
                                            "eo-de": "#currentPage#/#maxPages#",
                                            "nl-be": "#currentPage#/#maxPages#",
                                            "en-ie": "#currentPage#/#maxPages#",
                                            "en-gb": "#currentPage#/#maxPages#",
                                            "eo-en": "#currentPage#/#maxPages#",
                                            "fr-be": "#currentPage#/#maxPages#"
                                        }
                                    },
                                    "textLong": {
                                        "both": {
                                            "et-ee": "Lk #currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "bg-bg": "Страница #currentPage# от #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "cs-cz": "Strana #currentPage# z #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "da-dk": "Side #currentPage# af #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "de-de": "Seite #currentPage# von #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "en-us": "Page #currentPage# of #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "es-es": "Página #currentPage# de #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "fi-fi": "Sivu #currentPage# / #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "fr-fr": "Page #currentPage# de #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "el-gr": "Σελίδα #currentPage# από #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "hi-in": "#maxPages# (#mainCurrentPage#/#mainMaxPages#) का पृष्ठ #currentPage#",
                                            "hr-hr": "Stranica #currentPage# od #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "hu-hu": "#currentPage#. oldal; összesen #maxPages# oldal (#mainCurrentPage#/#mainMaxPages#)",
                                            "it-it": "Pagina #currentPage# di #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "ja-jp": "ページ #currentPage# / #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "ko-kr": "#currentPage#/#maxPages#페이지(#mainCurrentPage#/#mainMaxPages#)",
                                            "lt-lt": "#currentPage# psl. iš #maxPages# (#mainCurrentPage# / #mainMaxPages#)",
                                            "mk-mk": "Страница #currentPage# од #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "mn-mn": "Хуудас #currentPage#, нийт #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "ms-id": "Halaman #currentPage# dari #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "nl-nl": "Pagina #currentPage# van #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "no-no": "Side #currentPage# av #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "pl-pl": "Strona #currentPage# z #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "pt-pt": "Página #currentPage# de #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "ro-ro": "Pagina #currentPage# din #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "ru-ru": "Стр. #currentPage# из #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "sk-sk": "Strana #currentPage# z #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "sl-si": "Stran #currentPage# od #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "sr-rs": "Strana #currentPage# od #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "sv-se": "Sida #currentPage# av #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "th-th": "หน้า#currentPage# จาก #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "tr-tr": "Sayfa #currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "zh-tw": "第 #currentPage# 頁，共 #maxPages# 頁 (#mainCurrentPage#/#mainMaxPages#)",
                                            "zh-cn": "页码 #currentPage#/#maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "de-at": "Seite #currentPage# von #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "de-ch": "Seite #currentPage# von #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "eo-de": "Seite #currentPage# von #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "nl-be": "Pagina #currentPage# van #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "en-ie": "Page #currentPage# of #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "en-gb": "Page #currentPage# of #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "eo-en": "Seite #currentPage# von #maxPages# (#mainCurrentPage#/#mainMaxPages#)",
                                            "fr-be": "Page #currentPage# de #maxPages# (#mainCurrentPage#/#mainMaxPages#)"
                                        },
                                        "main": {
                                            "et-ee": "Lk #currentPage#/#maxPages#",
                                            "bg-bg": "Страница #currentPage# от #maxPages#",
                                            "cs-cz": "Strana #currentPage# z #maxPages#",
                                            "da-dk": "Side #currentPage# af #maxPages#",
                                            "de-de": "Seite #currentPage# von #maxPages#",
                                            "en-us": "Page #currentPage# of #maxPages#",
                                            "es-es": "Página #currentPage# de #maxPages#",
                                            "fi-fi": "Sivu #currentPage# / #maxPages#",
                                            "fr-fr": "Page #currentPage# de #maxPages#",
                                            "el-gr": "Σελίδα #currentPage# από #maxPages#",
                                            "hi-in": "#maxPages# का पृष्ठ #currentPage#",
                                            "hr-hr": "Stranica #currentPage# od #maxPages#",
                                            "hu-hu": "#currentPage#. oldal; összesen #maxPages# oldal",
                                            "it-it": "Pagina #currentPage# di #maxPages#",
                                            "ja-jp": "ページ #currentPage# / #maxPages#",
                                            "ko-kr": "#currentPage#/#maxPages#페이지",
                                            "lt-lt": "#currentPage# psl. iš #maxPages#",
                                            "mk-mk": "Страница #currentPage# од #maxPages#",
                                            "mn-mn": "Хуудас #currentPage#, нийт #maxPages#",
                                            "ms-id": "Halaman #currentPage# dari #maxPages#",
                                            "nl-nl": "Pagina #currentPage# van #maxPages#",
                                            "no-no": "Side #currentPage# av #maxPages#",
                                            "pl-pl": "Strona #currentPage# z #maxPages#",
                                            "pt-pt": "Página #currentPage# de #maxPages#",
                                            "ro-ro": "Pagina #currentPage# din #maxPages#",
                                            "ru-ru": "Стр. #currentPage# из #maxPages#",
                                            "sk-sk": "Strana #currentPage# z #maxPages#",
                                            "sl-si": "Stran #currentPage# od #maxPages#",
                                            "sr-rs": "Strana #currentPage# od #maxPages#",
                                            "sv-se": "Sida #currentPage# av #maxPages#",
                                            "th-th": "หน้า#currentPage# จาก #maxPages#",
                                            "tr-tr": "Sayfa #currentPage#/#maxPages#",
                                            "zh-tw": "第 #currentPage# 頁，共 #maxPages# 頁",
                                            "zh-cn": "页码 #currentPage#/#maxPages#",
                                            "de-at": "Seite #currentPage# von #maxPages#",
                                            "de-ch": "Seite #currentPage# von #maxPages#",
                                            "eo-de": "Seite #currentPage# von #maxPages#",
                                            "nl-be": "Pagina #currentPage# van #maxPages#",
                                            "en-ie": "Page #currentPage# of #maxPages#",
                                            "en-gb": "Page #currentPage# of #maxPages#",
                                            "eo-en": "Seite #currentPage# von #maxPages#",
                                            "fr-be": "Page #currentPage# de #maxPages#"
                                        },
                                        "sub": {
                                            "et-ee": "Lk #currentPage#/#maxPages#",
                                            "bg-bg": "Страница #currentPage# от #maxPages#",
                                            "cs-cz": "Strana #currentPage# z #maxPages#",
                                            "da-dk": "Side #currentPage# af #maxPages#",
                                            "de-de": "Seite #currentPage# von #maxPages#",
                                            "en-us": "Page #currentPage# of #maxPages#",
                                            "es-es": "Página #currentPage# de #maxPages#",
                                            "fi-fi": "Sivu #currentPage# / #maxPages#",
                                            "fr-fr": "Page #currentPage# de #maxPages#",
                                            "el-gr": "Σελίδα #currentPage# από #maxPages#",
                                            "hi-in": "#maxPages# का पृष्ठ #currentPage#",
                                            "hr-hr": "Stranica #currentPage# od #maxPages#",
                                            "hu-hu": "#currentPage#. oldal; összesen #maxPages# oldal",
                                            "it-it": "Pagina #currentPage# di #maxPages#",
                                            "ja-jp": "ページ #currentPage# / #maxPages#",
                                            "ko-kr": "#currentPage#/#maxPages#페이지",
                                            "lt-lt": "#currentPage# psl. iš #maxPages#",
                                            "mk-mk": "Страница #currentPage# од #maxPages#",
                                            "mn-mn": "Хуудас #currentPage#, нийт #maxPages#",
                                            "ms-id": "Halaman #currentPage# dari #maxPages#",
                                            "nl-nl": "Pagina #currentPage# van #maxPages#",
                                            "no-no": "Side #currentPage# av #maxPages#",
                                            "pl-pl": "Strona #currentPage# z #maxPages#",
                                            "pt-pt": "Página #currentPage# de #maxPages#",
                                            "ro-ro": "Pagina #currentPage# din #maxPages#",
                                            "ru-ru": "Стр. #currentPage# из #maxPages#",
                                            "sk-sk": "Strana #currentPage# z #maxPages#",
                                            "sl-si": "Stran #currentPage# od #maxPages#",
                                            "sr-rs": "Strana #currentPage# od #maxPages#",
                                            "sv-se": "Sida #currentPage# av #maxPages#",
                                            "th-th": "หน้า#currentPage# จาก #maxPages#",
                                            "tr-tr": "Sayfa #currentPage#/#maxPages#",
                                            "zh-tw": "第 #currentPage# 頁，共 #maxPages# 頁",
                                            "zh-cn": "页码 #currentPage#/#maxPages#",
                                            "de-at": "Seite #currentPage# von #maxPages#",
                                            "de-ch": "Seite #currentPage# von #maxPages#",
                                            "eo-de": "Seite #currentPage# von #maxPages#",
                                            "nl-be": "Pagina #currentPage# van #maxPages#",
                                            "en-ie": "Page #currentPage# of #maxPages#",
                                            "en-gb": "Page #currentPage# of #maxPages#",
                                            "eo-en": "Seite #currentPage# von #maxPages#",
                                            "fr-be": "Page #currentPage# de #maxPages#"
                                        }
                                    },
                                    "percent": {
                                        "both": {
                                            "et-ee": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "bg-bg": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "cs-cz": "#currentPathPercent# % (#mainPathPercent# %)",
                                            "da-dk": "#currentPathPercent# % (#mainPathPercent# %)",
                                            "de-de": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "en-us": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "es-es": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "fi-fi": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "fr-fr": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "el-gr": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "hi-in": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "hr-hr": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "hu-hu": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "it-it": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "ja-jp": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "ko-kr": "#currentPathPercent#%(#mainPathPercent#%)",
                                            "lt-lt": "#currentPathPercent# % (#mainPathPercent# %)",
                                            "mk-mk": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "mn-mn": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "ms-id": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "nl-nl": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "no-no": "#currentPathPercent# % (#mainPathPercent# %)",
                                            "pl-pl": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "pt-pt": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "ro-ro": "#currentPathPercent# % (#mainPathPercent# %)",
                                            "ru-ru": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "sk-sk": "#currentPathPercent# % (#mainPathPercent# %)",
                                            "sl-si": "#currentPathPercent# % (#mainPathPercent# %)",
                                            "sr-rs": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "sv-se": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "th-th": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "tr-tr": "%#currentPathPercent# (%#mainPathPercent#)",
                                            "zh-tw": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "zh-cn": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "de-at": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "de-ch": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "eo-de": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "nl-be": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "en-ie": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "en-gb": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "eo-en": "#currentPathPercent#% (#mainPathPercent#%)",
                                            "fr-be": "#currentPathPercent#% (#mainPathPercent#%)"
                                        },
                                        "main": {
                                            "et-ee": "#currentPathPercent#%",
                                            "bg-bg": "#currentPathPercent#%",
                                            "cs-cz": "#currentPathPercent# %",
                                            "da-dk": "#currentPathPercent# %",
                                            "de-de": "#currentPathPercent#%",
                                            "en-us": "#currentPathPercent#%",
                                            "es-es": "#currentPathPercent#%",
                                            "fi-fi": "#currentPathPercent#%",
                                            "fr-fr": "#currentPathPercent#%",
                                            "el-gr": "#currentPathPercent#%",
                                            "hi-in": "#currentPathPercent#%",
                                            "hr-hr": "#currentPathPercent#%",
                                            "hu-hu": "#currentPathPercent#%",
                                            "it-it": "#currentPathPercent#%",
                                            "ja-jp": "#currentPathPercent#%",
                                            "ko-kr": "#currentPathPercent#%",
                                            "lt-lt": "#currentPathPercent# %",
                                            "mk-mk": "#currentPathPercent#%",
                                            "mn-mn": "#currentPathPercent#%",
                                            "ms-id": "#currentPathPercent#%",
                                            "nl-nl": "#currentPathPercent#%",
                                            "no-no": "#currentPathPercent# %",
                                            "pl-pl": "#currentPathPercent#%",
                                            "pt-pt": "#currentPathPercent#%",
                                            "ro-ro": "#currentPathPercent# %",
                                            "ru-ru": "#currentPathPercent#%",
                                            "sk-sk": "#currentPathPercent# %",
                                            "sl-si": "#currentPathPercent# %",
                                            "sr-rs": "#currentPathPercent#%",
                                            "sv-se": "#currentPathPercent#%",
                                            "th-th": "#currentPathPercent#%",
                                            "tr-tr": "%#currentPathPercent#",
                                            "zh-tw": "#currentPathPercent#%",
                                            "zh-cn": "#currentPathPercent#%",
                                            "de-at": "#currentPathPercent#%",
                                            "de-ch": "#currentPathPercent#%",
                                            "eo-de": "#currentPathPercent#%",
                                            "nl-be": "#currentPathPercent#%",
                                            "en-ie": "#currentPathPercent#%",
                                            "en-gb": "#currentPathPercent#%",
                                            "eo-en": "#currentPathPercent#%",
                                            "fr-be": "#currentPathPercent#%"
                                        },
                                        "sub": {
                                            "et-ee": "#currentPathPercent#%",
                                            "bg-bg": "#currentPathPercent#%",
                                            "cs-cz": "#currentPathPercent# %",
                                            "da-dk": "#currentPathPercent# %",
                                            "de-de": "#currentPathPercent#%",
                                            "en-us": "#currentPathPercent#%",
                                            "es-es": "#currentPathPercent#%",
                                            "fi-fi": "#currentPathPercent#%",
                                            "fr-fr": "#currentPathPercent#%",
                                            "el-gr": "#currentPathPercent#%",
                                            "hi-in": "#currentPathPercent#%",
                                            "hr-hr": "#currentPathPercent#%",
                                            "hu-hu": "#currentPathPercent#%",
                                            "it-it": "#currentPathPercent#%",
                                            "ja-jp": "#currentPathPercent#%",
                                            "ko-kr": "#currentPathPercent#%",
                                            "lt-lt": "#currentPathPercent# %",
                                            "mk-mk": "#currentPathPercent#%",
                                            "mn-mn": "#currentPathPercent#%",
                                            "ms-id": "#currentPathPercent#%",
                                            "nl-nl": "#currentPathPercent#%",
                                            "no-no": "#currentPathPercent# %",
                                            "pl-pl": "#currentPathPercent#%",
                                            "pt-pt": "#currentPathPercent#%",
                                            "ro-ro": "#currentPathPercent# %",
                                            "ru-ru": "#currentPathPercent#%",
                                            "sk-sk": "#currentPathPercent# %",
                                            "sl-si": "#currentPathPercent# %",
                                            "sr-rs": "#currentPathPercent#%",
                                            "sv-se": "#currentPathPercent#%",
                                            "th-th": "#currentPathPercent#%",
                                            "tr-tr": "%#currentPathPercent#",
                                            "zh-tw": "#currentPathPercent#%",
                                            "zh-cn": "#currentPathPercent#%",
                                            "de-at": "#currentPathPercent#%",
                                            "de-ch": "#currentPathPercent#%",
                                            "eo-de": "#currentPathPercent#%",
                                            "nl-be": "#currentPathPercent#%",
                                            "en-ie": "#currentPathPercent#%",
                                            "en-gb": "#currentPathPercent#%",
                                            "eo-en": "#currentPathPercent#%",
                                            "fr-be": "#currentPathPercent#%"
                                        }
                                    }
                                }
                            }
                        }
                    };

                /**
                 * Gets data from a nested object
                 *
                 * @private
                 * @param {string} key - a dot separated representation of the objectstructure e.g.("cmi.core.lesson_status")
                 * @param {object|string} data - the data object where the value should be got from
                 */
                function getData( key, data ) {

                    var parts = key.split("."),
                        i = 0,
                        parent = data;

                    for(; i < parts.length; ++i) {
                        if (!parent[parts[i]]) {
                            return null;
                        }
                        parent = parent[parts[i]];
                    }

                    return parent;
                }

                // revealing public API
                return {

                    /**
                     * Gets a text in a given language
                     * If the text is not defined in the given language, the text in teh fallback "en-us" is used, otherwise "null".
                     *
                     * @public
                     * @param {string} key - a dot separated representation of the resource e.g.("quiz.evaluate")
                     * @param {string} [language] - the language for the text e.g.("en-us")
                     */
                    get : function( key, language ){

                        var text = getData( key, texts );
                        if( text ){
                            return getData( language, text ) || getData( fallbackLanguage, text );
                        }

                        return null;
                    }
                }
            })(),
            ElementIds = {
    	        "main" : "mainPathProgress",
                "sub" : "parallelPathProgress",
                "both" : "bothPathProgress"
            },
            VisibilityUtil = {
                checkMainPathProgressVisibility : function( config ){
                    return ( config.learningPathVisibility === "both" ) || ( config.learningPathVisibility === "main" && config.currentStepIsInMainPath );
                },

                checkSubPathProgressVisibility : function( config ){
                    return !config.currentStepIsInMainPath && ( config.learningPathVisibility === "sub" || config.learningPathVisibility === "both" );
                },
                progressIsVisible : function( config ) {

                    if( config.learningPathVisibility === "both" ) {
                        return true;
                    }

                    if( config.currentStepIsInMainPath ) {
                        return config.learningPathVisibility === "main";
                    }

                    return config.learningPathVisibility === "sub";
                }
            };

		function ProgressBarBuilder( config ){

            function createMainProgressBar(){

                var pe = createProgressElement()
                    .css( "background-color", config.barMainBackgroundColor );

                pe.html("<div></div>")
                  .children(":first")
                  .css({
                      "height": "100%",
                      "background-color": config.barMainProgressColor
                  });

                return pe;
            }

            function createProgressElement() {
                return jq(document.createElement("div"))
                    .css({
                        "position": "absolute",
                        "left": "0px",
                        "top": "0px",
                        "width": "100%",
                        "height": "100%"
                    })
                    // test id
                    .addClass( ElementIds["main"] );
            }

            function createSubProgressBar(){

                var pe = createSubProgressElement();

                pe.css({
                    // use 50% height in case the main path is also displayed
                    "height": config.learningPathVisibility === "sub" ? "100%" : "50%",
                    "background-color": config.barSubBackgroundColor
                 })
                 .html("<div></div>")
                 .children(":first")
                 .css({
                     "height" : "100%",
                     "background-color" :  config.barSubProgressColor
                 });


                return pe;
            }

            function createSubProgressElement() {
                return jq(document.createElement("div"))
                    .css({
                        "position" : "absolute",
                        "right": "0px",
                        "top" : config.learningPathVisibility === "sub" ? "0" : "50%",
                        "width": "100%"
                    })
                    // test id
                    .addClass( ElementIds["sub"] );
            }

            function setProgressWidth( progressElement, progress ){
                jq(progressElement).children(":first").css({"width": progress + "%"});
            }

            return {
				build : function( shellElement ){

                    if( !VisibilityUtil.progressIsVisible(config) ){
                        if( context.stage.isInAuthoringMode() ){
                            shellElement.css( "border", "1px dotted #ff0000" );
                        }
                        return;
                    }

                    if( VisibilityUtil.checkMainPathProgressVisibility(config) ){
                        var mainProgressElement = createMainProgressBar();
                        setProgressWidth( mainProgressElement, config.progressMain );
                        shellElement.append( mainProgressElement );
                    }

                    if( VisibilityUtil.checkSubPathProgressVisibility(config) ){
                        var subProgressElement = createSubProgressBar();
                        shellElement.append( subProgressElement );
                        setProgressWidth( subProgressElement, config.progressSub );
                    }
                }
            };
        }

        function ProgressTextBuilder( config ) {

		    function getTestId(){

                if( config.learningPathVisibility === "both" ){
                    return config.currentStepIsInMainPath ? "main" : "sub";
                }

                return config.learningPathVisibility;
            }

            function getTextId(){

                if( config.learningPathVisibility === "both" ){
                    return config.currentStepIsInMainPath ? "main" : "both";
                }

                return config.learningPathVisibility;
            }


            function createProgressElement() {

                var testId = ElementIds[ getTestId() ];
                return jq(document.createElement("div"))
                    .css({
                        "position" : "absolute",
                        "left": "0px",
                        "top": "0px",
                        "width": "100%",
                        "height": "100%"
                    })
                    .addClass( testId );
            }

            function addProgressTextStyles( element ) {
                return jq(element)
                    .css({
                        "color" : config.textColor,
                        "font-size" : config.fontSize,
                        "font-family" : getFontFamilyString( config.fontFamily ),
                        "text-align" : config.textAlign
                    });
            }

            function getFontFamilyString(fontFamily) {
                switch (parseInt(fontFamily)) {
                    case 2:
                        return "'Times New Roman', Times, serif";
                    case 3:
                        return "Verdana, Geneva, sans-serif";
                    case 4:
                        return "'Courier New', Courier, monospace";
                    case 1:
                    default:
                }
                return "Arial, Helvetica, sans-serif";
            }

            function getDisplayText(){

                var stageVarMainPathPos = context.stage.variable.get('mainPathCurrentPage', 'Progress'),
                    stageVarMainPathAllCount = context.stage.variable.get('mainPathAllPagesCount', 'Progress'),
                    mainPathPos = stageVarMainPathPos === null ? 0 : stageVarMainPathPos,
                    currentMainPathAllCount = stageVarMainPathAllCount === null ? 0 : stageVarMainPathAllCount,
                    textKey = "player.navigation.progress." + config.textMode + "." + getTextId(),
                    textContent = uiText.get( textKey, mContentLanguage ),
                    numberLength = mAllPagesCount.toString().length;

                textContent = textContent.replace( "#currentPage#", number_pad( config.currentPos, numberLength ) );
                textContent = textContent.replace( "#maxPages#", config.allPagesCount );

                numberLength = currentMainPathAllCount.toString().length;
                textContent = textContent.replace( "#mainCurrentPage#", number_pad( mainPathPos, numberLength ) );
                textContent = textContent.replace( "#mainMaxPages#", currentMainPathAllCount );

                // Percent
                textContent = textContent.replace( "#currentPathPercent#", config.currentStepIsInMainPath ? config.progressMain : config.progressSub );
                textContent = textContent.replace( "#mainPathPercent#", config.progressMain );

                return textContent;
            }

            return {
                build: function (shellElement) {

                    if( !VisibilityUtil.progressIsVisible(config) ){
                        if( context.stage.isInAuthoringMode() ){
                            shellElement.css( "border", "1px dotted #ff0000" );
                        }
                        return;
                    }

                    var progressElement = createProgressElement();
                    progressElement.text( getDisplayText() );
                    addProgressTextStyles( progressElement );
                    shellElement.append( progressElement );
                }
            };
        }

		var mProgressMain = 0,
			mProgressSub = 0,
			mCurrentPos = 0,
			mAllPagesCount = 0,
			mIsStandardPlayer = context.getPlayerName() === "standard",
			mContentLanguage = metadata.stage.getContentLanguage(),
			mParameters = metadata.parameters,
			mDisplayMode = mParameters.get("displayMode", "bar"),
            mTextMode = mParameters.get("textMode", "textLong");


		function currentStepIsInMainPath(){

			if( mIsStandardPlayer ) {
                var currentLearningPath = metadata.page.getLearningPath();
                if( currentLearningPath ) {
                    return currentLearningPath.isMainLearningPath();
                }
            }

            return true;
		}

		function getCurrentLearningPath(){
            return (mIsStandardPlayer) ? metadata.page.getLearningPath() : metadata.stage;
		}

		function initProgressValues(){

			var myId = metadata.page.getId(),
				currentLearningPath = getCurrentLearningPath();

			// get pages count
            mAllPagesCount = 0;
            jq.each( currentLearningPath.pages, function(k,p){
				mAllPagesCount++;
				// if this is current position, set current page count
				if (p.getId() === myId) {
					mCurrentPos = mAllPagesCount;
				}
            });

			if( currentStepIsInMainPath() ){
				mProgressMain = (mAllPagesCount > 0) ? Math.round((mCurrentPos / mAllPagesCount) * 100) : 0;
				mProgressSub = 0;
				// remember current main progress so we can use it within sub path
				context.stage.variable.set('mainPathCurrentPage', mCurrentPos, 'Progress');
				context.stage.variable.set('mainPathAllPagesCount', mAllPagesCount, 'Progress');
				context.stage.variable.set('subPathCurrentPage', 0, 'Progress');
				context.stage.variable.set('subPathAllPagesCount', 0, 'Progress');
			}
			else {
				mProgressMain = (context.stage.variable.get('mainPathAllPagesCount', 'Progress') > 0) ? Math.round((context.stage.variable.get('mainPathCurrentPage', 'Progress') / context.stage.variable.get('mainPathAllPagesCount', 'Progress')) * 100) : 0;
				mProgressSub = (mAllPagesCount > 0) ? Math.round((mCurrentPos / mAllPagesCount) * 100) : 0;
				context.stage.variable.set('subPathCurrentPage', mCurrentPos, 'Progress');
				context.stage.variable.set('subPathAllPagesCount', mAllPagesCount, 'Progress');
			}
		}

		function number_pad(num, size) {
			if( mParameters.asBool("leadingZeros", false) === true ) {
				var s = num + "";
				while (s.length < size){
					s = "0" + s;
                }
				return s;
			} else {
				return num;
			}
		}

		// is neccessary testing
		function getSCTestWrapperSelectors(){
			return "progressBarWrapper showProgressOnPathType_" + mParameters.get("useLearningPathMode", "both") +  " displayAs_" + (mDisplayMode === "bar" ? mDisplayMode : mTextMode)
		}

		function createHTML() {

			var shellElement = jq(context.getElement())
				.css({
					"width": metadata.getWidth() + "px",
					"height": metadata.getHeight() + "px"
				})
				// can be used to identify progress bar type from outside of the component (ex. integration tests)
				.addClass(getSCTestWrapperSelectors());

            shellElement.children( "." + ElementIds["main"] ).remove();
            shellElement.children( "." + ElementIds["sub"] ).remove();

            if( mDisplayMode === "bar" ){
                new ProgressBarBuilder({
                    currentStepIsInMainPath : currentStepIsInMainPath(),
                    learningPathVisibility : mParameters.get("useLearningPathMode", "both"),
                    progressMain : mProgressMain,
                    progressSub : mProgressSub,
                    barMainBackgroundColor : mParameters.asCssColor("backgroundMainPath", "#5d5d5d"),
                    barMainProgressColor : mParameters.asCssColor("colorMainPath", "#0398e6"),
                    barSubBackgroundColor : mParameters.asCssColor("backgroundParallelPath", "#7a7a7a"),
                    barSubProgressColor : mParameters.asCssColor("colorParallelPath", "#b1cfdd")
                }).build( shellElement );
			}
			else {
                new ProgressTextBuilder({
                    currentStepIsInMainPath : currentStepIsInMainPath(),
                    learningPathVisibility : mParameters.get("useLearningPathMode", "both"),
                    textMode : mTextMode,
                    textColor :  mParameters.asCssColor("color", "#000000"),
                    fontSize : mParameters.asNumber( "fontSize", 14) + "px",
                    fontFamily : mParameters.asNumber( "fontFamily", 1),
                    textAlign : mParameters.get("textOrientation", "center"),
                    currentPos : mCurrentPos,
                    allPagesCount : mAllPagesCount,
                    progressMain : mProgressMain,
                    progressSub : mProgressSub
                }).build( shellElement );
			}
		}

        // revealing public API
		return {
			onLoading : function() {
				context.page.event.bindOnEnter( this );
                if (context.stage.isInAuthoringMode()) {
                    createHTML();
                }
			},

			onEnterPage : function() {
                initProgressValues();
                createHTML();
			}
		};
	};
});